package com.taglib.wdjsp.filters;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import javax.servlet.ServletException;
import java.io.IOException;

public class AuthenticationFilter implements Filter {

  private String loginPage;
  private UserSessionManager sessionMgr;

  public AuthenticationFilter () {
    sessionMgr = UserSessionManager.getInstance();
  }
  public void init (FilterConfig config) throws ServletException {
    loginPage = config.getInitParameter("loginPage");
    if (loginPage == null)
      throw new ServletException("The loginPage init parameter"
				 + " must be specified.");
  }

  public void doFilter (ServletRequest request, ServletResponse response,
			FilterChain chain) 
    throws IOException, ServletException {
    if (request instanceof HttpServletRequest
	&& response instanceof HttpServletResponse) {
      HttpServletRequest req = (HttpServletRequest) request;
      HttpSession session = req.getSession(true);
      UserBean user = sessionMgr.getSessionUser(session);
      if  (user == null) {
	requireLogin(req, (HttpServletResponse) response, session);
      } else {
	chain.doFilter(request, response);
      }
    } else {
      throw new ServletException("Filter only applicable"
				 + " to HTTP and HTTPS requests.");
    }
  }
  private void requireLogin (HttpServletRequest request,
			     HttpServletResponse response, 
			     HttpSession session)
    throws IOException {
    StringBuffer buffer = request.getRequestURL();
    String query = request.getQueryString();
    if (query != null) {
      buffer.append('?');
      buffer.append(query);
    }
    sessionMgr.setSessionLoginTarget(session, buffer.toString());
    UserSessionManager.doRedirect(request, response, loginPage);
  }

  public void destroy () {}
}
