package com.taglib.wdjsp.filters;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import javax.servlet.ServletException;
import java.io.IOException;

public class RoleFilter implements Filter {
  private String role, denyPage;
  private UserSessionManager sessionMgr;

  public RoleFilter () {
    sessionMgr = UserSessionManager.getInstance();
  }

  public void init (FilterConfig config) throws ServletException {
    role = config.getInitParameter("role");
    if (role == null)
      throw new ServletException("The role init parameter"
				 + " must be specified.");
    denyPage = config.getInitParameter("denyPage");
    if (denyPage == null)
      throw new ServletException("The denyPage init parameter"
				 + " must be specified.");
  }


  public void doFilter (ServletRequest request, ServletResponse response,
			FilterChain chain) 
    throws IOException, ServletException {
    if (request instanceof HttpServletRequest
	&& response instanceof HttpServletResponse) {
      HttpServletRequest req = (HttpServletRequest) request;
      HttpSession session = req.getSession(true);
      UserBean user = sessionMgr.getSessionUser(session);
      if ((user != null) && user.hasRole(role)) {
	chain.doFilter(request, response);
      } else {
	HttpServletResponse resp = (HttpServletResponse) response;
	UserSessionManager.doRedirect(req, resp, denyPage);
      }
    } else {
      throw new ServletException("Filter only applicable"
				 + " to HTTP and HTTPS requests.");
    }
  }

  public void destroy () {}
}
