package com.taglib.wdjsp.filters;

import java.util.List;
import java.util.ArrayList;

public class UserBean {
    private String username, firstName, lastName;
    List roles;

    public UserBean () {
	this("", "", "");
    }
    public UserBean (String username, String firstName, String lastName) {
	this.username = username;
	this.firstName = firstName;
	this.lastName = lastName;
	this.roles = new ArrayList();
    }

    public String getUsername () { return username; }
    public String getFirstName () { return firstName; }
    public String getLastName () { return lastName; }

    public void setUsername (String username) { this.username = username; }
    public void setFirstName (String firstName) { this.firstName = firstName; }
    public void setLastName (String lastName) { this.lastName = lastName; }

    public void addRole (String role) {
	if (! roles.contains(role)) roles.add(role);
    }
    public void removeRole (String role) {
	int index = roles.indexOf(role);
	if (index >= 0) roles.remove(index);
    }
    public boolean hasRole (String role) {
	return roles.contains(role);
    }
}

