package com.taglib.wdjsp.mut;

import javax.servlet.jsp.tagext.TagLibraryValidator;
import javax.servlet.jsp.tagext.ValidationMessage;
import javax.servlet.jsp.tagext.PageData;
import java.io.InputStream;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.io.InputStreamReader;
import java.io.BufferedReader;

import java.io.IOException;

public class CopyingTLV extends TagLibraryValidator {

    private static String DEST_FILE = "/Users/mark/tmp/ParsedPage.xml"; 

    public ValidationMessage[] validate (String prefix, String uri,
					  PageData page) {
	InputStream in = null;
	try {
	    in = page.getInputStream();
	    copyToFile(in, DEST_FILE);
	}
	catch (IOException e) {
	    return new ValidationMessage[] {
	      new ValidationMessage(null, e.getMessage()) };
	}
	finally {
	    if (in != null) try { in.close(); } catch (IOException e) {}
	}
	return null;
    }

    private void copyToFile (InputStream stream, String filename) 
	throws IOException {
	PrintWriter out = null;
	BufferedReader in = null;
	try {
	    out = new PrintWriter(new FileWriter(filename));
	    in = new BufferedReader(new InputStreamReader(stream));
	    String line;
	    while ((line = in.readLine()) != null) {
		out.println(line);
	    }
	}
	finally {
	    if (out != null) out.close();
	    if (in != null) in.close();
	}
    }
}
