package com.taglib.wdjsp.mut;

import javax.servlet.jsp.tagext.Tag;
import javax.servlet.jsp.tagext.BodyTag;
import javax.servlet.jsp.tagext.BodyTagSupport;
import javax.servlet.jsp.tagext.BodyContent;
import javax.servlet.jsp.tagext.TryCatchFinally;

import java.io.IOException;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspTagException;

public class FailsafeTag 
    extends BodyTagSupport implements TryCatchFinally {
    private String alt = null;
    private boolean caught = false;

    public String getAlt () { return alt; }
    public void setAlt (String alt) { this.alt = alt; }

    public int doStartTag () throws JspException {
	caught = false;
	return BodyTag.EVAL_BODY_BUFFERED;
    }
    public int doAfterBody () throws JspException {
        BodyContent body = getBodyContent();
	String content = body.getString();
        body.clearBody();
	try {
	    getPreviousOut().print(content);
	}
	catch (IOException e) {
	    throw new JspTagException("I/O exception " + e.getMessage());
	}
	return SKIP_BODY;
    }
    public void release () {
	super.release();
	alt = null;
    }

    public void doCatch (Throwable t) {
	caught = true;
    }
    public void doFinally () {
	if (caught && (alt != null)) {
	    try {
		getPreviousOut().print(alt);
	    }
	    catch (IOException e) {}
	}
    }
}
