package com.taglib.wdjsp.mut;

import java.util.Calendar;
import java.util.TimeZone;

public class TimeOfDayBean {
    Calendar now;

    public TimeOfDayBean () {
	now = Calendar.getInstance();
    }
    public TimeOfDayBean (String zone) {
	now = Calendar.getInstance(TimeZone.getTimeZone(zone));
    }

    public int getHour () {
	return now.get(Calendar.HOUR_OF_DAY);
    }
    public boolean isMorning () {
	int hour = getHour();
	return (hour >= 6) && (hour < 12);
    }

    public boolean isAfternoon () {
	int hour = getHour();
	return (hour >= 12) && (hour < 18);
    }

    public boolean getDaytime () {
	return isMorning() || isAfternoon();
    }
    public String toString () {
	return now.getTime().toString();
    }

    public static void main (String[] args) {
	TimeOfDayBean tod = null;
	if (args.length > 0) {
	    String zone = args[0];
	    tod = new TimeOfDayBean(zone);
	} else {
	    tod = new TimeOfDayBean();
	}
	System.out.println("Time is " + tod + ".");
	System.out.println("Hour is " + tod.getHour() + ".");
    }
}
